17aa40
From 8e322f5bc24547963978be071a8a2547abad875a Mon Sep 17 00:00:00 2001
17aa40
From: Henri Chain <henri.chain@enioka.com>
17aa40
Date: Tue, 5 Oct 2021 13:10:31 +0200
17aa40
Subject: [PATCH] core: fix SIGABRT on empty exec command argv
17aa40
17aa40
This verifies that the argv part of any exec_command parameters that
17aa40
are sent through dbus is not empty at deserialization time.
17aa40
17aa40
There is an additional check in service.c service_verify() that again
17aa40
checks if all exec_commands are correctly populated, after the service
17aa40
has been loaded, whether through dbus or otherwise.
17aa40
17aa40
Fixes #20933.
17aa40
17aa40
(cherry picked from commit 29500cf8c47e6eb0518d171d62aa8213020c9152)
17aa40
17aa40
Resolves: #2020239
17aa40
---
17aa40
 src/core/dbus-execute.c             |  4 ++++
17aa40
 src/core/service.c                  | 12 +++++++++++
17aa40
 test/TEST-23-TYPE-EXEC/testsuite.sh | 31 +++++++++++++++++++++++++++++
17aa40
 3 files changed, 47 insertions(+)
17aa40
17aa40
diff --git a/src/core/dbus-execute.c b/src/core/dbus-execute.c
17aa40
index 8348663000..2e64f0baf4 100644
17aa40
--- a/src/core/dbus-execute.c
17aa40
+++ b/src/core/dbus-execute.c
17aa40
@@ -969,6 +969,10 @@ int bus_set_transient_exec_command(
17aa40
                 if (r < 0)
17aa40
                         return r;
17aa40
 
17aa40
+                if (strv_isempty(argv))
17aa40
+                        return sd_bus_error_setf(error, SD_BUS_ERROR_INVALID_ARGS,
17aa40
+                                                 "\"%s\" argv cannot be empty", name);
17aa40
+
17aa40
                 r = sd_bus_message_read(message, "b", &b);
17aa40
                 if (r < 0)
17aa40
                         return r;
17aa40
diff --git a/src/core/service.c b/src/core/service.c
17aa40
index 5e3e75b5ae..12adf89dd4 100644
17aa40
--- a/src/core/service.c
17aa40
+++ b/src/core/service.c
17aa40
@@ -536,6 +536,18 @@ static int service_verify(Service *s) {
17aa40
         if (UNIT(s)->load_state != UNIT_LOADED)
17aa40
                 return 0;
17aa40
 
17aa40
+        for (ServiceExecCommand c = 0; c < _SERVICE_EXEC_COMMAND_MAX; c++) {
17aa40
+                ExecCommand *command;
17aa40
+
17aa40
+                LIST_FOREACH(command, command, s->exec_command[c])
17aa40
+                        if (strv_isempty(command->argv)) {
17aa40
+                                log_unit_error(UNIT(s),
17aa40
+                                               "Service has an empty argv in %s=. Refusing.",
17aa40
+                                               service_exec_command_to_string(c));
17aa40
+                                return -ENOEXEC;
17aa40
+                        }
17aa40
+        }
17aa40
+
17aa40
         if (!s->exec_command[SERVICE_EXEC_START] && !s->exec_command[SERVICE_EXEC_STOP]) {
17aa40
                 log_unit_error(UNIT(s), "Service lacks both ExecStart= and ExecStop= setting. Refusing.");
17aa40
                 return -ENOEXEC;
17aa40
diff --git a/test/TEST-23-TYPE-EXEC/testsuite.sh b/test/TEST-23-TYPE-EXEC/testsuite.sh
17aa40
index 80734bbbdc..e0c34cfd04 100755
17aa40
--- a/test/TEST-23-TYPE-EXEC/testsuite.sh
17aa40
+++ b/test/TEST-23-TYPE-EXEC/testsuite.sh
17aa40
@@ -21,6 +21,37 @@ systemd-run --unit=four -p Type=exec /bin/sleep infinity
17aa40
 ! systemd-run --unit=five -p Type=exec -p User=idontexist /bin/sleep infinity
17aa40
 ! systemd-run --unit=six -p Type=exec /tmp/brokenbinary
17aa40
 
17aa40
+# For issue #20933
17aa40
+
17aa40
+# Should work normally
17aa40
+busctl call \
17aa40
+  org.freedesktop.systemd1 /org/freedesktop/systemd1 \
17aa40
+  org.freedesktop.systemd1.Manager StartTransientUnit \
17aa40
+  "ssa(sv)a(sa(sv))" test-20933-ok.service replace 1 \
17aa40
+    ExecStart "a(sasb)" 1 \
17aa40
+      /usr/bin/sleep 2 /usr/bin/sleep 1 true \
17aa40
+  0
17aa40
+
17aa40
+# DBus call should fail but not crash systemd
17aa40
+busctl call \
17aa40
+  org.freedesktop.systemd1 /org/freedesktop/systemd1 \
17aa40
+  org.freedesktop.systemd1.Manager StartTransientUnit \
17aa40
+  "ssa(sv)a(sa(sv))" test-20933-bad.service replace 1 \
17aa40
+    ExecStart "a(sasb)" 1 \
17aa40
+      /usr/bin/sleep 0 true \
17aa40
+  0 && { echo 'unexpected success'; exit 1; }
17aa40
+
17aa40
+# Same but with the empty argv in the middle
17aa40
+busctl call \
17aa40
+  org.freedesktop.systemd1 /org/freedesktop/systemd1 \
17aa40
+  org.freedesktop.systemd1.Manager StartTransientUnit \
17aa40
+  "ssa(sv)a(sa(sv))" test-20933-bad-middle.service replace 1 \
17aa40
+    ExecStart "a(sasb)" 3 \
17aa40
+      /usr/bin/sleep 2 /usr/bin/sleep 1 true \
17aa40
+      /usr/bin/sleep 0                  true \
17aa40
+      /usr/bin/sleep 2 /usr/bin/sleep 1 true \
17aa40
+  0 && { echo 'unexpected success'; exit 1; }
17aa40
+
17aa40
 systemd-analyze set-log-level info
17aa40
 
17aa40
 echo OK > /testok